# Rutile
Yet another compiled programming language.
Very unstable and in early development.

```
proc main*(): cint
{
  puts("Hello, world!")
  return 0
}
```

## Building
### Build time dependencies
- C11 C compiler (tested on GCC, Clang and TCC)
- Libc
- BSD or GNU Make
- POSIX shell
- `find` command

### Build time dependencies (single header libraries)
These are contained in `compiler/libs`.
- [stb_ds.h](https://github.com/nothings/stb)
- [optparse](https://github.com/skeeto/optparse)

### Procedure
Note that the default `CFLAGS` and `LDFLAGS` are meant for development builds.
```sh
# debug build (uses default flags):
make -j$(nproc) ptgc
# for release:
make -j$(nproc) CFLAGS='-O2 -march=native -DNDEBUG' LDFLAGS='' ASAN=''
```

## License
GNU GPLv3 for the compiler and BSD 3-Clause for the standard library.

## Acknowledgements
- Christopher Wellons, for his public domain libraries.
- Sean Barrett's `stb_ds.h`.
